program inetget;

{$mode objfpc}{$H+}

uses
  Exec, sysutils;
const
  AF_INET = 2;
  SOCK_STREAM = 1;
  
type
  TSockAddr = record
    sa_len: Byte; 
    sa_family: Byte; 
    sa_data: array[0..13] of Char; 
  end;
  PSockAddr = ^TSockAddr;


  in_addr = record
    s_Addr: LongWord;
  end;
  TInetSockAddr = record
    sin_len: byte;
    sin_Family: Byte;
    sin_port: smallInt;
    sin_Addr: in_addr;
    sin_zero: array[0..7] of Char;
  end;
  PInetSockAddr = ^TInetSockAddr;

var
  BSDSocketBase: Pointer;

function Socket(Domain: Integer; Typ: Integer; Protocol: Integer): Integer;
type
  TLocalCall = function(Domain: Integer; Typ: Integer; Protocol: Integer; Base: Pointer): Integer; cdecl;
var
  Call: TLocalCall;
begin
  Call := TLocalCall(GetLibAdress(BSDSocketBase, 5));
  Socket := Call(Domain, Typ, Protocol, BSDSocketBase);
end;

function Connect(s: Integer; Name: PSockAddr; NameLen: Integer): Integer;
type
  TLocalCall = function(s: Integer; Name: PSockAddr; NameLen: Integer; Base: Pointer): Integer; cdecl;
var
  Call: TLocalCall;
begin
  Call := TLocalCall(GetLibAdress(BSDSocketBase, 9));
  Connect := Call(s, Name, NameLen, BSDSocketBase);
end;

function Send(s: Integer; Msg: Pointer; Len: Integer; Flags: Integer): Integer;
type
  TLocalCall = function(s: Integer; Msg: Pointer; Len: Integer; Flags: Integer; Base: Pointer): Integer; cdecl;
var
  Call: TLocalCall;
begin
  Call := TLocalCall(GetLibAdress(BSDSocketBase, 11));
  Send := Call(s, Msg, Len, Flags, BSDSocketBase);
end;

function Recv(s: Integer; Msg: Pointer; Len: Integer; Flags: Integer): Integer;
type
  TLocalCall = function(s: Integer; Msg: Pointer; Len: Integer; Flags: Integer; Base: Pointer): Integer; cdecl;
var
  Call: TLocalCall;
begin
  Call := TLocalCall(GetLibAdress(BSDSocketBase, 13));
  Recv := Call(s, Msg, Len, Flags, BSDSocketBase);
end;

function Shutdown(s: Integer; How: Integer): Integer;
type
  TLocalCall = function(s: Integer; How: Integer; Base: Pointer): Integer; cdecl;
var
  Call: TLocalCall;
begin
  Call := TLocalCall(GetLibAdress(BSDSocketBase, 14));
  Shutdown := Call(s, How, BSDSocketBase);
end;

function CloseSocket(s: Integer): Integer;
type
  TLocalCall = function(s: Integer; Base: Pointer): Integer; cdecl;
var
  Call: TLocalCall;
begin
  Call := TLocalCall(GetLibAdress(BSDSocketBase, 20));
  CloseSocket := Call(s, BSDSocketBase);
end;


function htons(host: word): word; inline;
begin
  {$ifdef FPC_BIG_ENDIAN}
  htons := host;
  {$else}
  htons := swap(host);
  {$endif}
end;

type
  THostAddr= packed array[1..4] of byte;
  
function htonl(host: longint): longint; inline;
begin
  {$ifdef FPC_BIG_ENDIAN}
  htonl := host;
  {$else}
  htonl := THostAddr(host)[4];
  htonl := htonl or longint(THostAddr(host)[3] shl 8);
  htonl := htonl or longint(THostAddr(host)[2] shl 16);
  htonl := htonl or longint(THostAddr(host)[1] shl 24);    
  {$endif}
end;

function NToHl (Net : Longint) : Longint; inline;
begin
{$ifdef FPC_BIG_ENDIAN}
  ntohl:=net;
{$else}
  ntohl:=THostAddr(Net)[4];
  ntohl:=ntohl or longint( (THostAddr(Net)[3]) shl 8);
  ntohl:=ntohl or longint( (THostAddr(Net)[2]) shl 16);
  ntohl:=ntohl or longint( (THostAddr(Net)[1]) shl 24);
{$endif}
end;

function StrToHostAddr(IP : AnsiString): in_addr;
Var
  Dummy: AnsiString;
  I,j,k: Longint;
  Temp: in_addr;
begin
  strtohostaddr.s_addr:=0;              //:=NoAddress;
  for I := 1 to 4 do
  begin
    if I < 4 Then
    begin
      J := Pos('.', IP);
      If J = 0 then
        exit;
      Dummy := Copy(IP, 1, J - 1);
      Delete (IP, 1, J);
    end else
      Dummy:=IP;
    Val(Dummy,k,J);
    THostAddr(temp.s_addr)[i] := k;
    if J <> 0 then
      Exit;
   end;
   strtohostaddr.s_addr := ntohl(Temp.s_addr);
end;

function StrToNetAddr(ip: AnsiString): in_addr;
begin
  StrToNetAddr.s_addr := htonl(StrToHostAddr(IP).s_addr);
end;

Var
  Addr : TInetSockAddr;
  S,i : Longint;
  f: File;
  Line : string;
  Buffer: array[0..4095] of Char;
  num: Integer;
  Filename: string = 'test.html';
begin
  if ParamStr(1) <> '' then
    FileName := ParamStr(1);
  Assign(F, FileName);
  rewrite(f, 1);
  
  BSDSocketBase := OpenLibrary('bsdsocket.library', 0);
  Addr.sin_len := sizeof(Addr);
  Addr.sin_family:=AF_INET;
  Addr.sin_port:=htons(80);
  //Addr.sin_addr.s_addr:=StrToNetAddr('192.168.0.254').s_Addr;
  Addr.sin_addr.s_addr:=StrToNetAddr('50.87.149.192').s_Addr; // Amiga.org
  S:=Socket(AF_INET,SOCK_STREAM,0);
  writeln('socket: ',s);
  if s >= 0 then
  begin
    i := connect(S, @addr, Addr.sin_len);
    writeln('connect: ',i);
    if i >= 0 then
    begin
      line:= 'GET / HTTP/1.0'#10#10#0;
      num := send(s, @line[1], Length(Line), 0);
      writeln('Number of Chars send: ', num);
      //sleep(100); // wait a little bit to answer the server
      repeat
        FillChar(Buffer[0],Length(Buffer), #0);
        num := Recv(s, @Buffer, Length(Buffer), 0);        
        writeln('###### Got ', num,' chars');
        //writeln(PChar(@Buffer[0]));
        BlockWrite(F, Buffer[0], num);
      until num <= 0;
    end;  
    shutdown(s, 2);
  end;
  CloseSocket(s);
  Close(f); 
  CloseLibrary(BSDSocketBase);
end.

